﻿Type=Class
Version=2.02
@EndOfDesignText@
'version: 1.00
Sub Class_Globals
	Private ges As Gestures
	Private pnl As Panel
	Private cvs As Canvas
	Public NONE, LEFT, RIGHT, UP, DOWN
	NONE = 0
	LEFT = 1
	RIGHT = 2
	UP = 3
	DOWN = 4
	Type joystick(x As Float, y As Float, zeroX As Float, zeroY As Float, color As Int)
	Dim jleft, jright As joystick
	Private radius As Int
	radius = 15dip
End Sub

Public Sub Initialize
	pnl.Initialize("")
	ges.SetOnTouchListener(pnl, "pnl_multitouch")
	jleft.Initialize
	jleft.color = Colors.Red
	jright.Initialize
	jright.color = Colors.Blue
End Sub

Public Sub AddToActivity(act As Activity, vLeft As Int, vTop As Int, vWidth As Int, vHeight As Int)
	Dim iv1, iv2 As ImageView
	iv1.Initialize("")
	iv2.Initialize("")
	iv1.Bitmap = LoadBitmap(File.DirAssets, "arrows.png")
	iv2.Bitmap = iv1.Bitmap
	iv1.Gravity = Gravity.FILL
	iv2.Gravity = Gravity.FILL
	act.AddView(iv1, vLeft, vTop, vHeight, vHeight)
	act.AddView(iv2, vLeft + vWidth - vHeight, vTop, vHeight, vHeight)
	act.AddView(pnl, vLeft, vTop, vWidth, vHeight)
	cvs.Initialize(pnl)
	jleft.zeroX = pnl.Height / 2
	jleft.zeroY = pnl.Height / 2
	jright.zeroX = pnl.Width - pnl.Height / 2
	jright.zeroY = pnl.Height / 2
	MoveJoystick(jleft.zeroX, jleft.zeroY, jleft)
	MoveJoystick(jright.zeroX, jright.zeroY, jright)
	pnl.Invalidate
End Sub

Private Sub pnl_multitouch(View As Object, pointerID As Int, action As Int, x As Float, Y As Float) As Boolean
	Dim foundLeft, foundRight As Boolean
	For i = 0 To ges.GetPointerCount - 1
		If (action = ges.ACTION_UP OR action = ges.ACTION_POINTER_UP) AND _
			ges.GetPointerID(i) = pointerID Then
				Continue
		End If
		If ges.GetX(i) = -1 AND ges.GetY(i) = -1 Then Continue
		Dim gx, gy As Float
		gx = Max(0, Min(ges.GetX(i), pnl.Width))
		gy = Max(0, Min(ges.GetY(i), pnl.Height))
		If gx < pnl.Width / 2 Then
			gx = Min(gx, pnl.Height)
			foundLeft = True
			MoveJoystick(gx, gy, jleft)
		Else
			gx = Max(gx, pnl.Width - pnl.Height)
			foundRight = True
			MoveJoystick(gx, gy, jright)
		End If
	Next
	If Not(foundLeft) Then MoveJoystick(jleft.zeroX, jleft.zeroY, jleft)
	If Not(foundRight) Then MoveJoystick(jright.zeroX, jright.zeroY, jright)
	pnl.Invalidate
	Return True
End Sub

Private Sub MoveJoystick(x As Float, y As Float, j As joystick)
	cvs.DrawCircle(j.x, j.y, radius, Colors.Transparent, True, 0)
	Dim valuex, valuey As Float
	valuex = x - j.zeroX
	valuey = y - j.zeroY
	If Abs(valuex) > Abs(valuey) Then y = j.zeroY Else x = j.zeroX
	j.x = x
	j.y = y
	cvs.DrawCircle(j.x, j.y, radius, j.color, True, 0)
End Sub

Public Sub GetLeftValue As Int
	Return GetValue(jleft)
End Sub

Public Sub GetRightValue As Int
	Return GetValue(jright)
End Sub

Private Sub GetValue(j As joystick) As Int
	If Power(j.x - j.zeroX, 2) + Power(j.y - j.zeroY, 2) < Power(pnl.Height / 3, 2) Then
		Return NONE
	Else If j.x < j.zeroX Then 
		Return LEFT
	Else If j.x > j.zeroX Then
		Return RIGHT
	Else If j.y > j.zeroY Then
		Return DOWN
	Else If j.y < j.zeroY Then
		Return UP
	End If
End Sub